module HAL.Doc.EntityTree where

import Data.Aeson ((.:), (.:?), (.!=), FromJSON(..), withObject)
import Data.Default
import GHC.Generics
import Protolude hiding (show)
import Protolude.Base (Show(..))
import Servant.API (ToHttpApiData(..))


data EntityTree = EntityTree
  {
    _docid :: Text,
    _label_s :: Maybe Text,
    _parentEntityTreeid_i :: [Text]
  } deriving (Generic)

instance Default EntityTree where
  def = EntityTree "" def def

instance FromJSON EntityTree where
  parseJSON = withObject "EntityTree" $
    \o -> EntityTree <$> (o .: "docid")
                     <*> (o .:? "label_s")
                     <*> (o .:? "parentEntityTreeid_i" .!= [])

instance ToHttpApiData EntityTree where
  toUrlPiece _ = "docid,label_s,parentEntityTreeid_i"

instance Show EntityTree where
  show (EntityTree { .. }) = show _label_s <> "(" <> show _docid <> ")"
