{-# LANGUAGE TemplateHaskell #-}

module HAL.Doc.Struct where

import Data.Aeson
import Data.Default
import GHC.Generics
import Protolude
import Servant.API (ToHttpApiData(..))
import qualified Control.Lens as L

data Struct = Struct
  {
    _struct_docid :: Int,
    _struct_label :: Text,
    _struct_parent_docid :: [Text]
  } deriving (Show, Generic)
L.makeLenses ''Struct

instance Default Struct where
  def = Struct def "" def

instance FromJSON Struct where
  parseJSON = withObject "Struct" $
    \o -> Struct <$> (o .: "docid")
                 <*> (o .: "label_s")
                 <*> (o .: "parentDocid_i" <|> return [])

instance ToHttpApiData Struct where
  toUrlPiece _ = "docid,label_s,parentDocid_i"
